' === EZ1toLCD.bas ======= 2009.09.09 ======= Ron Hackett ===

'  This program runs on the SERVO TankBot.
'	It uses a MaxSonar EZ1 module to measure distance to
'	the nearest object and sends the results to the 8X2 LCD.

	
' === Constants ===

	symbol abit = 100		' used for pauses between packets
	symbol  EZ1 =   1		' EZ1 on AnalogIn1
	symbol  LED =   2		' LED on output2
	
'  HD44780 Commands
	symbol L1 = 128		 move cursor to position 1 of line 1
	symbol L2 = 192		 move cursor to position 1 of line 2

	
' === Variables ===

	symbol dist = w0		' data from EZ1	

	
' === Directives ===

	'#com3					' specify serial port
	#picaxe 14M				' specify processor


' === Begin Main Program ====================================

dirsc = %00000110				' set the I/O pin directions

wait 1							' allow for LCD initialization

do
  	high LED						' for debugging
  	pause 250
 
  	readadc10 EZ1,dist		' get EZ1 raw data
  	dist = dist / 2			' convert to inches 	
  	sertxd (L1,"Distance")	' send line 1 to LCD
  	
  	pause abit					' required between packets
  	
  	sertxd (L2)					' cursor at start of line 2 
  	if dist < 10 then			' move one space right
  	  	sertxd (" ")			' for single-digit readings
  	endif							' to make 9-byte total
  	sertxd (#dist," inch.") ' send line 2 to LCD
  	
  	low LED
  	pause 250
 loop								' loop forever